const ____Data____ = require("./data");

/**
 * 打印http请求报文
 * @param {"http请求对象"} args_Request 
 */
module.exports.do_ParseRequest = (args_Request) => {

	let t_Body = "";

	t_Body += args_Request.method + " " + args_Request.url + " " + "HTTP" + args_Request.httpVersion;
	t_Body += "\r\n";
	//t_Body += "headers";

	let temp_Keys = Object.keys(args_Request.headers);
	for (let i = 0; i < temp_Keys.length; i++) {
		t_Body += "\r\n";
		// t_Body += "\t";
		t_Body += temp_Keys[i] + ":" + args_Request.headers[temp_Keys[i]];
	}

	t_Body += "\r\n";
	t_Body += "\r\n";
	t_Body += "socket:";
	t_Body += "\r\n\t";
	t_Body += "remoteAddress:" + args_Request["socket"]["remoteAddress"];
	t_Body += "\r\n\t";
	t_Body += "remoteFamily:" + args_Request["socket"]["remoteFamily"];
	t_Body += "\r\n\t";
	t_Body += "remotePort:" + args_Request["socket"]["remotePort"];



	//query部分
	t_Body += "\r\n";
	t_Body += "\r\n";
	t_Body += "query:";
	for (let temp_Key in args_Request.query) {
		t_Body += "\r\n\t";
		t_Body += temp_Key + ":【" + args_Request.query[temp_Key] + "】";
	}




	if (args_Request.method == "PUT") {

		//body部分
		t_Body += "\r\n";
		t_Body += "\r\n";
		t_Body += "body:";
		t_Body += "\r\n";

		if (args_Request.body == null) {
			t_Body += "\t【null】";
		}
		else {
			t_Body += "【" + args_Request.body.toString() + "】";
		}
	}
	else if (args_Request.method == "POST") {

		let temp_Content_Type = null;
		let temp_Standard_Type = ["application/x-www-form-urlencoded", "multipart/form-data"];
		let temp_Standard = true;
		if (("content-type" in args_Request.headers && args_Request.headers["content-type"] != null)) {

			temp_Content_Type = args_Request.headers["content-type"];
			let temp_Index = temp_Content_Type.indexOf(";");
			if (temp_Index > -1) {
				temp_Content_Type = temp_Content_Type.substring(0, temp_Index);
			}

			temp_Standard = temp_Standard_Type.includes(temp_Content_Type);
		}


		if (temp_Standard) {

			//body部分
			t_Body += "\r\n";
			t_Body += "\r\n";
			t_Body += "body:";
			for (let temp_Key in args_Request.form) {
				t_Body += "\r\n\t";
				t_Body += temp_Key + ":【" + args_Request.form[temp_Key] + "】";
			}


			if (temp_Content_Type != "multipart/form-data") {
				return t_Body;
			}

			//file部分
			t_Body += "\r\n";
			t_Body += "\r\n";
			t_Body += "file:";
			let temp_File = null;
			for (let temp_Key in args_Request.file) {
				temp_File = args_Request.file[temp_Key];
				t_Body += "\r\n\t";
				t_Body += "key:【" + temp_Key + "】," + "filename:【" + temp_File.filename + "】,extname:【" + temp_File.extname + "】,size:【" + temp_File.size + "】";
			}
		}
		else {

			//body部分
			t_Body += "\r\n";
			t_Body += "\r\n";
			t_Body += "body:";
			t_Body += "\r\n";

			//说明是JSON
			if (temp_Content_Type == "application/json") {

				if (args_Request.form == null) {
					t_Body += "\t【null】";
				}
				else {
					t_Body += "【" + JSON.stringify(args_Request.form, null, '    ') + "】";
				}
			}
			//认为是文本
			else {
				if (args_Request.form == null) {
					t_Body += "\t【null】";
				}
				else {
					t_Body += "【" + args_Request.form.toString() + "】";
				}
			}
		}
	}



	return t_Body;

}

/**
 * 检查http请求中的必要文件
 * @param {"对象类型：数据来源"}                       args_DataSource 
 * @param {"数组类型：要验证的键的数组"}                args_KeyArray 
 * @param {"回调函数：可以传入null"}                  args_Success 
 */
module.exports.do_Check_RequiredFile = (args_DataSource, args_KeyArray, args_Success) => {
	let temp_Lose = new Array();
	args_KeyArray.forEach(element => {

		/**
		 * in 操作符 先搜索【实例本身】的属性，没有再搜索【原型】的属性
		 * hasOwnProperty()函数 只搜索【实例本身】的属性。
		 * delete 操作符 只删除【实例本身】的属性
		 */

		if (!args_DataSource.hasOwnProperty(element)) {
			temp_Lose.push(element);
		}
		else if (args_DataSource[element] == null) {
			temp_Lose.push(element);
		}
		else {
			if (typeof (args_DataSource[element]) != "object") {
				temp_Lose.push(element);
			}
			else {
				if (
					args_DataSource[element].hasOwnProperty("size")
					&&
					args_DataSource[element].hasOwnProperty("type")
					&&
					args_DataSource[element].hasOwnProperty("path")
					&&
					args_DataSource[element].hasOwnProperty("name")
				) {
					/**
					 * 此情况说明是合法的file中的文件
					 */
				}
				else {
					temp_Lose.push(element);
				}
			}
		}
	});

	if (temp_Lose.length > 0) {
		/**
		 * 参数重复是指：
		 * http使用KeyValue编码的时候，使用重复（多个相同）的key值来表达数组
		 */
		let temp_Result = JSON.stringify(
			____Data____.do_DataPacket("fail", "required_file_are_missing", { "err_code": "required_file_are_missing", "err_desc": temp_Lose.join(",") })
			, null
			, '    '
		);

		if (args_Success != null) {
			args_Success(temp_Result);
		}
		return false;
	}
	else {
		return true;
	}
}

/**
 * 检查http请求中的必要参数
 * @param {"对象类型：数据来源"}                       args_DataSource 
 * @param {"数组类型：要验证的键的数组"}                args_KeyArray 
 * @param {"回调函数：可以传入null"}                  args_Success 
 */
module.exports.do_Check_RequiredName = (args_DataSource, args_KeyArray, args_Success) => {
	let temp_Lose = new Array();
	args_KeyArray.forEach(element => {

		/**
		 * in 操作符 先搜索【实例本身】的属性，没有再搜索【原型】的属性
		 * hasOwnProperty()函数 只搜索【实例本身】的属性。
		 * delete 操作符 只删除【实例本身】的属性
		 */

		if (Array.isArray(element)) {//认为是或的关系，存在一个就可以
			let temp_Exist = false;
			for (let p = 0; p < element.length; p++) {
				temp_Exist = module.exports.do_Check_Pairs(args_DataSource, element[p]);
				if (temp_Exist) {
					break;
				}
			}
			if (!temp_Exist) {
				temp_Lose.push(element.join("|"));
			}
		}
		else {
			if (!args_DataSource.hasOwnProperty(element)) {
				temp_Lose.push(element);
			}
			else if (args_DataSource[element] == null) {
				temp_Lose.push(element);
			}
			else {
				// if (Array.isArray(args_DataSource[element])) {
				// 	/**
				// 	 * 认为是不合格
				// 	 * 如果【content-type】=x-www-form-urlencoded，那么body中的重复的key作为数组来对待，这是http的规则，但是通常没有这么使用，也没有多少人知道这个规则
				// 	 */
				// 	temp_Lose.push(element);
				// }

				if (args_DataSource[element] == null) {
					{
						temp_Lose.push(element);
					}
				}
				else if (Number.isNaN(args_DataSource[element])) {
					{
						temp_Lose.push(element);
					}
				}
				else if (typeof (args_DataSource[element]) == "string") {
					if (args_DataSource[element].trim() == "") {
						temp_Lose.push(element);
					}
				}
			}
		}
	});

	if (temp_Lose.length > 0) {
		/**
		 * 参数重复是指：
		 * http使用KeyValue编码的时候，使用重复（多个相同）的key值来表达数组
		 */
		let temp_Result = JSON.stringify(
			____Data____.do_DataPacket("fail", "required_name_are_missing", { "err_code": "required_name_are_missing", "err_desc": temp_Lose.join(",") })
			, null
			, '    '
		);

		if (args_Success != null) {
			args_Success(temp_Result);
		}
		return false;
	}
	else {
		return true;
	}
}

/**
 * 如果给定的key在对象中，【存在】&&【不为null】&&【不为""】，则返回true，否则返回false
 * @param {"集合对象"}      args_DataSource 
 * @param {"要验证的键"}     args_DataKey 
 */
module.exports.do_Check_Pairs = (args_DataSource, args_DataKey) => {
	if (false == args_DataSource.hasOwnProperty(args_DataKey)) {
		return false;
	}
	if (args_DataSource[args_DataKey] == null) {
		return false;
	}
	if (typeof (args_DataSource[args_DataKey]) == "string") {
		if (args_DataSource[args_DataKey].trim() == "") {
			return false;
		}
	}

	return true;
}

/**
 * 校验是否符合电子邮件格式，符合返回true，否则返回false
 * @param {"邮件地址"}      args_Mail_Address 
 */
module.exports.do_Check_Mail_Address = (args_Mail_Address) => {

	if (args_Mail_Address.indexOf("@") == -1) {
		return false;
	}
	let temp_Spa2 = args_Mail_Address.split("@");
	if (temp_Spa2.length != 2) {
		return false;
	}

	let temp_Illigal = false;
	temp_Illigal = module.exports.do_Check_Mail_Section(temp_Spa2[0]);
	if (!temp_Illigal) {
		return false;
	}


	if (temp_Spa2[1].indexOf(".") == -1) {
		return false;
	}
	let temp_Spa3 = temp_Spa2[1].split(".");
	if (temp_Spa3.length < 2) {
		return false;
	}

	for (let i = 0; i < temp_Spa3.length; i++) {
		temp_Illigal = module.exports.do_Check_Mail_Section(temp_Spa3[i]);
		if (!temp_Illigal) {
			return false;
		}
	}
	return true;
}

module.exports.do_Check_Mail_Section = (args_Mail_Section) => {

	if (args_Mail_Section == "") {
		return false;
	}

	const temp_Ascii = "abcdefghijklmnopqrstuvwxyz0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ";
	const temp_Array = temp_Ascii.split("");
	const temp_Allow = [".", "-", "_"]


	if (!temp_Array.includes(args_Mail_Section[0])) {
		return false;
	}
	if (!temp_Array.includes(args_Mail_Section[args_Mail_Section.length - 1])) {
		return false;
	}
	if (args_Mail_Section.indexOf("..") > -1) {
		return false;
	}
	if (args_Mail_Section.indexOf("--") > -1) {
		return false;
	}
	if (args_Mail_Section.indexOf("-.") > -1) {
		return false;
	}
	if (args_Mail_Section.indexOf("-_") > -1) {
		return false;
	}
	if (args_Mail_Section.indexOf(".-") > -1) {
		return false;
	}
	if (args_Mail_Section.indexOf("._") > -1) {
		return false;
	}
	if (args_Mail_Section.indexOf("_-") > -1) {
		return false;
	}
	if (args_Mail_Section.indexOf("_.") > -1) {
		return false;
	}

	let temp_Char = "";
	let temp_clud = false;
	for (let i = 0; i < args_Mail_Section.length; i++) {
		temp_Char = args_Mail_Section[i];
		temp_clud = temp_Array.includes(temp_Char);
		if (!temp_clud) {
			if (!temp_Allow.includes(temp_Char)) {
				return false;
			}
		}
	}
	return true;
}